/* AppSearchListAdapter.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;

import de.dhbwloe.campusapp.R;

/**
 * Created by pk910 on 19.01.2016.
 */
public class AppSearchListAdapter  extends ArrayAdapter<AppSearchListItem> {
    private Context context;
    private int layoutResourceId;
    private ArrayList<AppSearchListItem> data = new ArrayList<AppSearchListItem>();

    public AppSearchListAdapter(Context context, int layoutResourceId, ArrayList<AppSearchListItem> data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View row = convertView;
        RecordHolder holder = null;

        if (row == null) {
            LayoutInflater inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            row = inflater.inflate(layoutResourceId, parent, false);

            holder = new RecordHolder(row);
            row.setTag(holder);
        } else {
            holder = (RecordHolder) row.getTag();
        }

        final AppSearchListAdapter that = this;
        final AppSearchListItem item = data.get(position);

        holder.resultTitle.setText(item.getTitle());
        holder.resultDescription.setText(item.getDescription());

        return row;
    }

    static class RecordHolder {
        TextView resultTitle;
        TextView resultDescription;

        public RecordHolder(View view) {
            this.resultTitle = (TextView) view.findViewById(R.id.resultTitle);
            this.resultDescription = (TextView) view.findViewById(R.id.resultDescription);
        }
    }
}
