/* DashboardNewsStuv.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import java.util.Collections;
import java.util.Comparator;
import java.util.Date;

import de.dhbwloe.campusapp.R;

/**
 * A simple {@link Fragment} subclass.
 */
public class DashboardNewsStuv extends News {
    private View newsEntryPanel;
    private View newsNonePanel;

    public DashboardNewsStuv() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        oFragmentView = new RelativeLayout(inflater.getContext());
        newsEntryPanel = inflater.inflate(R.layout.fragment_dashboard_news_entry, container, false);
        newsNonePanel = inflater.inflate(R.layout.fragment_dashboard_news_none, container, false);

        return oFragmentView;
    }

    @Override
    public void onResume() {
        super.onResume();

        refreshStuvNews();
    }

    private void refreshStuvNews() {
        loadNewsSource("STUV", false);
        loadEventsSource("STUV", false);

        Collections.sort(newsListItems, new Comparator<NewsListItem>() {
            @Override
            public int compare(NewsListItem item2, NewsListItem item1) {
                long now = (new Date()).getTime() / 1000;
                return (int) (item2.getTimeDifference(now) - item1.getTimeDifference(now));
            }
        });

        RelativeLayout container = (RelativeLayout) oFragmentView;
        container.removeAllViews();

        if(newsListItems.size() > 0) {
            container.addView(newsEntryPanel);

            TextView dateView = (TextView) newsEntryPanel.findViewById(R.id.newsDate);
            TextView titleView = (TextView) newsEntryPanel.findViewById(R.id.newsTitle);
            NewsListItem newsItem = newsListItems.get(0);

            dateView.setText(newsItem.getFormatedDate());
            titleView.setText(newsItem.getTitle());
        } else
            container.addView(newsNonePanel);
    }

}
