/* VorlesungsplanExamsListAdapter.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;

import de.dhbwloe.campusapp.CampusAppContext;
import de.dhbwloe.campusapp.R;

/**
 * Created by pk910 on 27.02.2016.
 */
public class VorlesungsplanExamsListAdapter extends ArrayAdapter<VorlesungsplanExamsListItem> {
    private Context context;
    private int layoutResourceId;
    private ArrayList<VorlesungsplanExamsListItem> data = new ArrayList<VorlesungsplanExamsListItem>();

    public VorlesungsplanExamsListAdapter(Context context, int layoutResourceId, ArrayList<VorlesungsplanExamsListItem> data) {
            super(context, layoutResourceId, data);
            this.layoutResourceId = layoutResourceId;
            this.context = context;
            this.data = data;
            }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
            View row = convertView;
            RecordHolder holder = null;

            if (row == null) {
            LayoutInflater inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            row = inflater.inflate(layoutResourceId, parent, false);

            holder = new RecordHolder(row);
            row.setTag(holder);
            } else {
            holder = (RecordHolder) row.getTag();
            }

    final VorlesungsplanExamsListAdapter that = this;
    final VorlesungsplanExamsListItem item = data.get(position);

            holder.groupName.setText(item.getGroupName());
            holder.eventDate.setText(item.getEventDate());
            holder.eventStart.setText(item.getEventStart());
            holder.eventEnd.setText(item.getEventEnd());
            holder.eventLocation.setText(item.getEventLocation());

            return row;
            }

    static class RecordHolder {
        TextView groupName;
        TextView eventDate;
        TextView eventLocation;
        TextView eventStart;
        TextView eventEnd;

        public RecordHolder(View view) {
            this.groupName = (TextView) view.findViewById(R.id.courseTitle);
            this.eventDate = (TextView) view.findViewById(R.id.eventDate);
            this.eventLocation = (TextView) view.findViewById(R.id.eventLocation);
            this.eventStart = (TextView) view.findViewById(R.id.eventStart);
            this.eventEnd = (TextView) view.findViewById(R.id.eventEnd);
        }
    }
}
