/* VorlesungsplanExamsListItem.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import java.text.SimpleDateFormat;
import java.util.Date;

import de.dhbwloe.campusapp.CampusAppContext;
import de.dhbwloe.campusapp.R;

/**
 * Created by pk910 on 28.02.2016.
 */
public class VorlesungsplanExamsListItem {
    private int groupId;
    private String courseName;
    private String groupName;
    private String eventLocation;
    private long eventStart, eventEnd;
    private int eventCount;

    public VorlesungsplanExamsListItem(int groupid, String coursename, String groupname, String eventlocation, long eventstart, long eventend, int eventcount) {
        groupId = groupid;
        courseName = coursename;
        groupName = groupname;
        eventLocation = eventlocation;
        eventStart = eventstart;
        eventEnd = eventend;
        eventCount = eventcount;
    }

    public int getGroupId() {
        return groupId;
    }

    public String getCourseName() {
        return courseName;
    }

    public String getGroupName() {
        return groupName;
    }

    public String getEventLocation() {
        return eventLocation;
    }

    public String getEventDate() {
        if(eventStart == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_date));
        Date date = new Date(eventStart*1000);
        return dateFormat.format(date);
    }

    public String getEventStart() {
        if(eventStart == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_time));
        Date date = new Date(eventStart*1000);
        return dateFormat.format(date);
    }

    public String getEventEnd() {
        if(eventEnd == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_time));
        Date date = new Date(eventEnd*1000);
        return dateFormat.format(date);
    }

    public int getEventCount() {
        return eventCount;
    }
}
