/* VorlesungsplanGroupsListItem.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import java.text.SimpleDateFormat;
import java.util.Date;

import de.dhbwloe.campusapp.CampusAppContext;
import de.dhbwloe.campusapp.R;

/**
 * Created by pk910 on 20.02.2016.
 */
public class VorlesungsplanGroupsListItem {
    private int groupId;
    private String courseName;
    private String groupName;
    private long firstEvent, lastEvent, nextEvent, nextKlausurEvent;
    private int eventCount;

    public VorlesungsplanGroupsListItem(int groupid, String coursename, String groupname, long firstevent, long lastevent, int eventcount, long nextevent, long nextklausur) {
        groupId = groupid;
        courseName = coursename;
        groupName = groupname;
        firstEvent = firstevent;
        lastEvent = lastevent;
        eventCount = eventcount;
        nextEvent = nextevent;
        nextKlausurEvent = nextklausur;
    }

    public int getGroupId() {
        return groupId;
    }

    public String getCourseName() {
        return courseName;
    }

    public String getGroupName() {
        return groupName;
    }

    public String getFirstEvent() {
        if(firstEvent == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_fulldate));
        Date date = new Date(firstEvent*1000);
        return dateFormat.format(date);
    }

    public String getLastEvent() {
        if(lastEvent == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_fulldate));
        Date date = new Date(lastEvent*1000);
        return dateFormat.format(date);
    }

    public String getNextEvent() {
        if(nextEvent == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_fulldate));
        Date date = new Date(nextEvent*1000);
        return dateFormat.format(date);
    }

    public String getNextKlausurEvent() {
        if(nextKlausurEvent == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_fulldate));
        Date date = new Date(nextKlausurEvent*1000);
        return dateFormat.format(date);
    }

    public int getEventCount() {
        return eventCount;
    }
}
