/* VorlesungsplanUpcomingDayListItem.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import de.dhbwloe.campusapp.CampusAppContext;
import de.dhbwloe.campusapp.R;
import de.dhbwloe.campusapp.Tools;
import de.dhbwloe.campusapp.vorlesungen.CourseEvent;

/**
 * Created by pk910 on 20.02.2016.
 */
public class VorlesungsplanUpcomingDayListItem {
    private long cardDate;
    private ArrayList<VorlesungsplanUpcomingCourseListItem> courses = new ArrayList<VorlesungsplanUpcomingCourseListItem>();

    public VorlesungsplanUpcomingDayListItem(long date) {
        cardDate = date;
    }

    public void addCourseEventsToContainer(LinearLayout container) {
        int courseEntries = container.getChildCount();

        CampusAppContext AppContext = CampusAppContext.getInstance();
        LayoutInflater inflater = (LayoutInflater) AppContext.getMainActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        while(courseEntries < courses.size()) {
            View view = inflater.inflate(R.layout.fragment_vorlesungsplan_upcoming_course, null);
            container.addView(view);
            courseEntries++;
        }

        int i;
        for(i = 0; i < courses.size(); i++) {
            View child = container.getChildAt(i);
            courses.get(i).updateContainerView(child);
            child.setVisibility(View.VISIBLE);
        }
        for(;i < courseEntries; i++) {
            View child = container.getChildAt(i);
            child.setVisibility(View.GONE);
        }
    }

    public String getFormatedDate() {
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_date));
        Date date = new Date(cardDate * 1000);

        int weekdayResIds[] = new int[] { R.string.week_sunday, R.string.week_monday, R.string.week_tuesday, R.string.week_wednesday, R.string.week_thursday, R.string.week_friday,  R.string.week_saturday };
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        int dow = cal.get(Calendar.DAY_OF_WEEK)-1;

        return CampusAppContext.getInstance().getResString(weekdayResIds[dow]) + ", " + dateFormat.format(date);
    }

    public void addCourseEvent(CourseEvent event) {
        VorlesungsplanUpcomingCourseListItem courseItem = new VorlesungsplanUpcomingCourseListItem(event);
        courses.add(courseItem);
    }

}
