/* WebBrowser.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.fragments;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;

import de.dhbwloe.campusapp.CampusAppFragment;
import de.dhbwloe.campusapp.R;

public class WebBrowser extends CampusAppFragment {
    private boolean bRedirectedToBrowser = false;
    private boolean bBrowserRunning = false;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_web_browser, container, false);
        WebView webview = (WebView) view.findViewById(R.id.browserWebView);

        Bundle args = getArguments();
        if(args == null) {
            AppContext.getNavigationManager().navigatePage("Dashboard", null, false);
            return null;
        }

        String str;
        if((str = args.getString("html")) != null) {
            showWebViewHtml(webview, str);
        }
        else if((str = args.getString("url")) != null) {
            Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(str));
            startActivity(browserIntent);

            bRedirectedToBrowser = true;
            return null;
        }

        return view;
    }

    private void showWebViewHtml(WebView webview, String html) {
        webview.loadData(html, "text/html", null);
    }

    @Override
    public  void onPause() {
        super.onPause();

        if(bRedirectedToBrowser)
            bBrowserRunning = true;
    }

    @Override
    public void onResume() {
        super.onResume();

        if(bRedirectedToBrowser && bBrowserRunning) {
            AppContext.getMainActivity().onBackPressed();
        }
    }

}
