/* IscRequestHelper.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.network;
import android.util.Log;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.AsyncHttpResponseHandler;

import net.fortuna.ical4j.data.CalendarBuilder;
import net.fortuna.ical4j.data.ParserException;
import net.fortuna.ical4j.model.Calendar;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;

import cz.msebera.android.httpclient.Header;

/**
 * Created by pk910 on 20.01.2016.
 */
public abstract class IscRequestHelper {

    protected void requestCalenderFromWeb(String url) {
        AsyncHttpClient client = new AsyncHttpClient();
        Log.i("HTTPClient", "Request: "+url);
        client.get(url, new AsyncHttpResponseHandler() {
            @Override
            public void onStart() {
            }
            @Override
            public void onSuccess(int statusCode, Header[] headers, byte[] response) {
                String plainisc = new String(response);
                // Google Calendar parse error!
                plainisc = plainisc.replaceAll("(X-APPLE-TRAVEL-ADVISORY-BEHAVIOR;)?ACKNOWLEDGED[:=][0-9TZ]+(:AUTOMATIC)?[\\r\\n]*", "");
                response = plainisc.getBytes();

                InputStream inputStream = new ByteArrayInputStream(response);
                parseIsc(inputStream);
            }
            @Override
            public void onFailure(int statusCode, Header[] headers, byte[] errorResponse, Throwable e) {
                String error = null;
                try {
                    error = new String(errorResponse, "US-ASCII");
                } catch (Exception e1) {
                }
                Log.i("HTTPClient", "  Error: " + statusCode + " - " + error);
                onCalendarRequestFail(statusCode, error);
            }
            @Override
            public void onRetry(int retryNo) {
            }
        });
    }

    private void parseIsc(InputStream input) {
        CalendarBuilder builder = new CalendarBuilder();
        Calendar calendar = null;
        try {
            calendar = builder.build(input);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ParserException e) {
            e.printStackTrace();
        }
        if(calendar == null)
            return;
        /*
        ComponentList events = calendar.getComponents(Component.VEVENT);
        ListIterator<Component> iterator = events.listIterator();
        while (iterator.hasNext()) {
            Component event = iterator.next();
            event.getProperties();
        }
        */
        onCalendarReceived(calendar);
    }

    protected abstract void onCalendarReceived(Calendar calendar);
    protected abstract void onCalendarRequestFail(int statusCode, String errorMessage);

}
