/* DhbwSearchHelper.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.search;

import android.util.Log;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.AsyncHttpResponseHandler;
import com.loopj.android.http.RequestParams;

import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import cz.msebera.android.httpclient.Header;
import de.dhbwloe.campusapp.fragments.AppSearchListItem;

/**
 * Created by pk910 on 25.01.2016.
 */
public class DhbwSearchHelper extends SearchHelper {

    public DhbwSearchHelper() {
        super(true);
    }

    @Override
    protected void processWebRequest(AsyncHttpResponseHandler handler, String keywords) {
        AsyncHttpClient client = new AsyncHttpClient();
        String url = "https://www.dhbw-loerrach.de/suche.html?&L=0";
        RequestParams params = new RequestParams();
        /*  WHAT THE HELL DO THEY REQUIRE FOR THEIR STUPID SEARCH!?
        tx_indexedsearch[_sections]:0
        tx_indexedsearch[_freeIndexUid]:_
        tx_indexedsearch[pointer]:0
        tx_indexedsearch[ext]:1
        tx_indexedsearch[defOp]:0
        tx_indexedsearch[sword]:paintball
        tx_indexedsearch[type]:1
        tx_indexedsearch[defOp]:0
        tx_indexedsearch[media]:-1
        tx_indexedsearch[lang]:-1
        tx_indexedsearch[sections]:0
        tx_indexedsearch[order]:rank_flag
        tx_indexedsearch[desc]:0
        tx_indexedsearch[results]:10
        tx_indexedsearch[group]:flat
        tx_indexedsearch[extResume]:0
        tx_indexedsearch[extResume]:1
        tx_indexedsearch[submit_button]:Suche
         */
        params.put("tx_indexedsearch[_sections]","0");
        params.put("tx_indexedsearch[_freeIndexUid]","_");
        params.put("tx_indexedsearch[pointer]","0");
        params.put("tx_indexedsearch[ext]","1");
        params.put("tx_indexedsearch[defOp]","0");
        params.put("tx_indexedsearch[sword]", keywords);
        params.put("tx_indexedsearch[type]","1");
        params.put("tx_indexedsearch[defOp]","0");
        params.put("tx_indexedsearch[media]","-1");
        params.put("tx_indexedsearch[lang]","-1");
        params.put("tx_indexedsearch[sections]","0");
        params.put("tx_indexedsearch[order]","rank_flag");
        params.put("tx_indexedsearch[desc]","0");
        params.put("tx_indexedsearch[results]","40");
        params.put("tx_indexedsearch[group]","flat");
        params.put("tx_indexedsearch[extResume]","0");
        params.put("tx_indexedsearch[extResume]","1");
        params.put("tx_indexedsearch[submit_button]","Suche");

        Log.i("DhbwSearchHelper", "Search: "+keywords+" ("+url+")");
        client.post(url, params, handler);
    }

    @Override
    protected List<AppSearchListItem> onHtmlDocumentReceived(Document document) {
        ArrayList<AppSearchListItem> results = new ArrayList<AppSearchListItem>();
        Elements searchResultsTables = document.select(".tx-indexedsearch-res > table");
        for(Element searchResultsTable : searchResultsTables) {
            SearchTarget target = new SearchTarget();
            target.setInAppTarget(true);
            target.setTargetUrl("WebBrowser");

            Elements titleLinkElement = searchResultsTable.select(".tx-indexedsearch-title > a");
            Elements descriptionElement = searchResultsTable.select(".tx-indexedsearch-descr");
            if(titleLinkElement.size() == 0 || titleLinkElement.size() == 0)
                continue;
            String title = titleLinkElement.get(0).text();
            String link = titleLinkElement.get(0).attr("href");
            if(!link.matches("^https?://.*"))
                link = "https://www.dhbw-loerrach.de/" + link;

            String description = descriptionElement.get(0).text();

            target.setArgument("url", link);

            AppSearchListItem result = new AppSearchListItem("DHBW: "+title, description, target);
            results.add(result);
        }
        return results;
    }

    @Override
    protected List<AppSearchListItem> onPlainTextReceived(byte[] data) {
        return null;
    }
}
