/* SearchIndices.java
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package de.dhbwloe.campusapp.search;

import java.util.ArrayList;
import java.util.Date;

import de.dhbwloe.campusapp.CampusAppContext;

/**
 * Created by pk910 on 19.01.2016.
 */
public class SearchIndices {
    private String keyname = null;
    private StringBuilder keywordsBuffer = new StringBuilder();
    protected boolean isStatic = false;
    protected String target = new String();
    protected String keywords = null;
    protected String title = null;
    protected String description = null;
    protected long updateTime = 0;

    public SearchIndices(String keyname) {
        this.keyname = keyname;
        this.updateTime = (new Date()).getTime()/1000;
    }

    public SearchIndices(String keyname, boolean isStatic) {
        this.keyname = keyname;
        this.isStatic = isStatic;
    }

    public void addKeyWord(String words) {
        if(keywordsBuffer.length() > 0)
            keywordsBuffer.append('\n');
        keywordsBuffer.append(words);
    }

    public void addKeyWord(int words) {
        addKeyWord(CampusAppContext.getInstance().getResString(words));
    }

    public void setTarget(String target) {
        this.target = target;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public void setDescription(int description) {
        this.description = CampusAppContext.getInstance().getResString(description);
    }

    public void setTitle(int title) {
        this.title = CampusAppContext.getInstance().getResString(title);
    }

    public void setUpdateTime(long updateTime) {
        this.updateTime = updateTime;
    }

    public String getKeyName() {
        return this.keyname;
    }

    public String getKeyWords() {
        return (this.keywords != null ? this.keywords : "") + this.keywordsBuffer.toString();
    }

    public boolean getIsStatic() {
        return this.isStatic;
    }

    public String getTarget() {
        return this.target;
    }

    public String getDescription() {
        return this.description;
    }

    public String getTitle() {
        return this.title;
    }

    public long getUpdateTime() {
        return this.updateTime;
    }
}

